/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;

function AlertWriter () {
	this._buffer = new Array();
	this.autoFlush = true;
	this.bufferSize = 5;
};

AlertWriter.prototype.init = function (obj) {};
AlertWriter.prototype.write = function (msg, level) {
	this._buffer.push(msg);
	if (this.autoFlush || this._buffer.length > this.bufferSize) {
		this.flush();
	}
};

AlertWriter.prototype.flush = function () {
	for (var i = 0; i < this._buffer.length; i++) {
		Cc['@mozilla.org/embedcomp/prompt-service;1']
		.getService(Ci.nsIPromptService)
		.alert(null, "ObmLogger", this._buffer[i]);
	}
	this._buffer = new Array();
};

AlertWriter.prototype.QueryInterface = function(aIID) {
	if (!aIID.equals(Ci.nsISupports) &&
	!aIID.equals(Ci.obmILoggerWriter)) {
		throw Cr.NS_ERROR_NO_INTERFACE;
	}
	return this;
};

// module

var AlertWriterModule = {
	mCID: Components.ID("{3a4a0dcc-ede2-4932-bb76-9a3c164c7e84}"),
	mContractID: "@obm.org/calendar/writer;1?type=alert",
	registerSelf: function (compMgr, fileSpec, location, type) {
		compMgr = compMgr.QueryInterface(Ci.nsIComponentRegistrar);
		compMgr.registerFactoryLocation(
			this.mCID,
			"OBM Logger Writter: Alert",
			this.mContractID,
			fileSpec,
			location,
			type
		);
	},
	getClassObject: function (compMgr, cid, iid) {
		if (!cid.equals(this.mCID)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		if (!iid.equals(Ci.nsIFactory)) {
			throw Cr.NS_ERROR_NOT_IMPLEMENTED;
		}
		return this.mFactory;
	},
	mFactory: {
		createInstance: function (outer, iid) {
			if (outer != null) {
				throw Cr.NS_ERROR_NO_AGGREGATION;
			}
			return (new AlertWriter()).QueryInterface(iid);
		}
	},

	canUnload: function(compMgr) {
		return true;
	}
};

function NSGetModule(compMgr, fileSpec) {
	return AlertWriterModule;
}

