/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;

function ConsoleWriter () {
	this._buffer = new Array();
	this.autoFlush = true;
	this.bufferSize = 5;
};

ConsoleWriter.prototype.init = function (obj) {};
ConsoleWriter.prototype.write = function (msg, level) {
	this._buffer.push(msg);
	if (this.autoFlush || this._buffer.length > this.bufferSize) {
		this.flush();
	}
};

ConsoleWriter.prototype.flush = function () {
	for (var i = 0; i < this._buffer.length; i++) {
		Cc["@mozilla.org/consoleservice;1"]
		.getService(Ci.nsIConsoleService)
		.logStringMessage(this._buffer[i]);
	}
	this._buffer = new Array();
};

ConsoleWriter.prototype.QueryInterface = function(aIID) {
	if (!aIID.equals(Ci.nsISupports) &&
	!aIID.equals(Ci.obmILoggerWriter)) {
		throw Cr.NS_ERROR_NO_INTERFACE;
	}
	return this;
};

// module
var ConsoleWriterModule = {
	mCID: Components.ID("{eb2cc8c9-30f5-46b9-95fc-914f6b3927b3}"),
	mContractID: "@obm.org/calendar/writer;1?type=console",
	registerSelf: function (compMgr, fileSpec, location, type) {
		compMgr = compMgr.QueryInterface(Ci.nsIComponentRegistrar);
		compMgr.registerFactoryLocation(
			this.mCID,
			"OBM Logger Writter: Console",
			this.mContractID,
			fileSpec,
			location,
			type
		);
	},
	getClassObject: function (compMgr, cid, iid) {
		if (!cid.equals(this.mCID)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		if (!iid.equals(Ci.nsIFactory)) {
			throw Cr.NS_ERROR_NOT_IMPLEMENTED;
		}
		return this.mFactory;
	},
	mFactory: {
		createInstance: function (outer, iid) {
			if (outer != null) {
				throw Cr.NS_ERROR_NO_AGGREGATION;
			}
			return (new ConsoleWriter()).QueryInterface(iid);
		}
	},

	canUnload: function(compMgr) {
		return true;
	}
};

function NSGetModule(compMgr, fileSpec) {
	return ConsoleWriterModule;
}

