/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;

function ObmRemoteAPI() {};

ObmRemoteAPI.prototype = {
	QueryInterface: function(aIID) {
		if (!aIID.equals(Ci.nsISupports) &&
			!aIID.equals(Ci.obmIRemoteAPI)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		return this;
	},

	/*
	 * obmIRemoteAPI
	 */

	createTaskProxy: function() {
		return Cc["@obm.org/obm-sync/taskproxy;1"].createInstance(Ci.obmITaskProxy);
	},
	createAddressBookProxy: function() {
		return Cc["@obm.org/obm-sync/addressbookproxy;1"].createInstance(Ci.obmIAddressBookProxy);
	},
	createCalendarProxy: function() {
		return Cc["@obm.org/obm-sync/calendarproxy;1"].createInstance(Ci.obmICalendarProxy);
	},
	createCategoriesProxy: function() {
		return Cc["@obm.org/obm-sync/categoriesproxy;1"].createInstance(Ci.obmICategoriesProxy);
	}
};

// module

var ObmRemoteAPIModule = {
	mCID: Components.ID("{753396e5-e801-47e4-a535-4a74912a9601}"),
	mContractID: "@obm.org/obm-sync/service;1",
	registerSelf: function (compMgr, fileSpec, location, type) {
		compMgr = compMgr.QueryInterface(Ci.nsIComponentRegistrar);
		compMgr.registerFactoryLocation(
			this.mCID,
			"OBM RemoteAPI Service",
			this.mContractID,
			fileSpec,
			location,
			type
		);
	},
	getClassObject: function (compMgr, cid, iid) {

		if (!cid.equals(this.mCID)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		if (!iid.equals(Ci.nsIFactory)) {
			throw Cr.NS_ERROR_NOT_IMPLEMENTED;
		}

		return this.mFactory;
	},
	mFactory: {
		createInstance: function (outer, iid) {
			if (outer != null) {
				throw Cr.NS_ERROR_NO_AGGREGATION;
			}
			return (new ObmRemoteAPI()).QueryInterface(iid);
		}
	},

	canUnload: function(compMgr) {
		return true;
	}
};

function NSGetModule(compMgr, fileSpec) {
	return ObmRemoteAPIModule;
}

